diff --git a/board/freescale/imx8mm_evk/README b/board/freescale/imx8mm_evk/README
index fa3f079f31..3307711d5d 100644
--- a/board/freescale/imx8mm_evk/README
+++ b/board/freescale/imx8mm_evk/README
@@ -30,7 +30,7 @@ $ export ATF_LOAD_ADDR=0x920000
 $ make flash.bin
 
 Burn the flash.bin to MicroSD card offset 33KB
-$sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=33
+$sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=33 conv=notrunc
 
 Boot
 ====
diff --git a/board/freescale/imx8mn_evk/README b/board/freescale/imx8mn_evk/README
index ff3d15c02b..ec007afb25 100644
--- a/board/freescale/imx8mn_evk/README
+++ b/board/freescale/imx8mn_evk/README
@@ -30,7 +30,7 @@ $ export ATF_LOAD_ADDR=0x960000
 $ make flash.bin
 
 Burn the flash.bin to MicroSD card offset 32KB
-$sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=32
+$sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=32 conv=notrunc
 
 Boot
 ====
diff --git a/board/freescale/imx8mp_evk/README b/board/freescale/imx8mp_evk/README
index 7dd3a9352a..3c64979be9 100644
--- a/board/freescale/imx8mp_evk/README
+++ b/board/freescale/imx8mp_evk/README
@@ -33,7 +33,7 @@ $ export ATF_LOAD_ADDR=0x960000
 $ make flash.bin
 
 Burn the flash.bin to the MicroSD card at offset 32KB
-$sudo dd if=flash.bin of=/dev/sd[x] bs=1K seek=32; sync
+$sudo dd if=flash.bin of=/dev/sd[x] bs=1K seek=32 conv=notrunc; sync
 
 Boot
 ====
diff --git a/board/freescale/imx8mq_evk/README b/board/freescale/imx8mq_evk/README
index 859f852255..2689459b9f 100644
--- a/board/freescale/imx8mq_evk/README
+++ b/board/freescale/imx8mq_evk/README
@@ -30,7 +30,7 @@ $ make imx8mq_evk_defconfig
 $ make flash.bin
 
 Burn the flash.bin to MicroSD card offset 33KB
-$sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=33
+$sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=33 conv=notrunc
 
 Boot
 ====
diff --git a/board/freescale/imx8qxp_mek/README b/board/freescale/imx8qxp_mek/README
index 6e4eb5996b..6f99d0e13e 100644
--- a/board/freescale/imx8qxp_mek/README
+++ b/board/freescale/imx8qxp_mek/README
@@ -43,7 +43,7 @@ Flash the binary into the SD card
 
 Burn the flash.bin binary to SD card offset 32KB:
 
-$ sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=32
+$ sudo dd if=flash.bin of=/dev/sd[x] bs=1024 seek=32 conv=notrunc
 
 Boot
 ====
diff --git a/board/freescale/imxrt1020-evk/README b/board/freescale/imxrt1020-evk/README
index abee7ca5f3..9bc5bc00bc 100644
--- a/board/freescale/imxrt1020-evk/README
+++ b/board/freescale/imxrt1020-evk/README
@@ -11,11 +11,11 @@ This will generate the SPL image called SPL and the u-boot.img.
 
 - Flash the SPL image into the micro SD card:
 
-sudo dd if=SPL of=/dev/sdX bs=1k seek=1; sync
+sudo dd if=SPL of=/dev/sdX bs=1k seek=1 conv=notrunc; sync
 
 - Flash the u-boot.img image into the micro SD card:
 
-sudo dd if=u-boot.img of=/dev/sdX bs=1k seek=128; sync
+sudo dd if=u-boot.img of=/dev/sdX bs=1k seek=128 conv=notrunc; sync
 
 - Jumper settings:
 
diff --git a/board/freescale/imxrt1050-evk/README b/board/freescale/imxrt1050-evk/README
index a7e68fa9b3..f321300246 100644
--- a/board/freescale/imxrt1050-evk/README
+++ b/board/freescale/imxrt1050-evk/README
@@ -11,11 +11,11 @@ This will generate the SPL image called SPL and the u-boot.img.
 
 - Flash the SPL image into the micro SD card:
 
-sudo dd if=SPL of=/dev/sdX bs=1k seek=1; sync
+sudo dd if=SPL of=/dev/sdX bs=1k seek=1 conv=notrunc; sync
 
 - Flash the u-boot.img image into the micro SD card:
 
-sudo dd if=u-boot.img of=/dev/sdX bs=1k seek=128; sync
+sudo dd if=u-boot.img of=/dev/sdX bs=1k seek=128 conv=notrunc; sync
 
 - Jumper settings:
 
diff --git a/board/freescale/mx6sabreauto/README b/board/freescale/mx6sabreauto/README
index 4c0fda1a2d..710026a05e 100644
--- a/board/freescale/mx6sabreauto/README
+++ b/board/freescale/mx6sabreauto/README
@@ -13,11 +13,11 @@ This will generate the SPL and u-boot-dtb.img binaries.
 
 - Flash the SPL binary into the SD card:
 
-$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 && sync
+$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 conv=notrunc && sync
 
 - Flash the u-boot-dtb.img binary into the SD card:
 
-$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 && sync
+$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 conv=notrunc && sync
 
 Booting via Falcon mode
 -----------------------
@@ -36,11 +36,11 @@ This will generate the SPL image called SPL and the u-boot-dtb.img.
 
 - Flash the SPL image into the SD card:
 
-$ sudo dd if=SPL of=/dev/sdb bs=1K seek=1 && sync
+$ sudo dd if=SPL of=/dev/sdb bs=1K seek=1 conv=notrunc && sync
 
 - Flash the u-boot-dtb.img image into the SD card:
 
-$ sudo dd if=u-boot-dtb.img of=/dev/sdb bs=1K seek=69 && sync
+$ sudo dd if=u-boot-dtb.img of=/dev/sdb bs=1K seek=69 conv=notrunc && sync
 
 Create a FAT16 boot partition to store uImage and the dtb file, then copy the files there:
 
diff --git a/board/freescale/mx6sabresd/README b/board/freescale/mx6sabresd/README
index 4ea4454b9f..974b0be175 100644
--- a/board/freescale/mx6sabresd/README
+++ b/board/freescale/mx6sabresd/README
@@ -25,11 +25,11 @@ This will generate the SPL and u-boot-dtb.img binaries.
 
 - Flash the SPL binary into the SD card:
 
-$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 && sync
+$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 conv=notrunc && sync
 
 - Flash the u-boot-dtb.img binary into the SD card:
 
-$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 && sync
+$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 conv=notrunc && sync
 
 
 2. Booting from eMMC
@@ -53,8 +53,8 @@ Mount the eMMC in the host PC:
 
 - Flash SPL and u-boot-dtb.img binaries into the eMMC:
 
-$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 && sync
-$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 && sync
+$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 conv=notrunc && sync
+$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 conv=notrunc && sync
 
 Set SW6 to eMMC 8-bit boot: 11010110
 
@@ -69,11 +69,11 @@ This will generate the SPL image called SPL and the u-boot-dtb.img.
 
 - Flash the SPL image into the SD card:
 
-$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 oflag=sync status=none && sync
+$ sudo dd if=SPL of=/dev/sdX bs=1K seek=1 oflag=sync status=none conv=notrunc && sync
 
 - Flash the u-boot-dtb.img image into the SD card:
 
-$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 oflag=sync status=none && sync
+$ sudo dd if=u-boot-dtb.img of=/dev/sdX bs=1K seek=69 oflag=sync status=none conv=notrunc && sync
 
 Create a partition for root file system and extract it there:
 
diff --git a/board/freescale/mx6ul_14x14_evk/README b/board/freescale/mx6ul_14x14_evk/README
index e101abe48c..70eb86efba 100644
--- a/board/freescale/mx6ul_14x14_evk/README
+++ b/board/freescale/mx6ul_14x14_evk/README
@@ -14,11 +14,11 @@ This will generate the SPL image called SPL and the u-boot.img.
 
 - Flash the SPL image into the micro SD card:
 
-sudo dd if=SPL of=/dev/mmcblk0 bs=1k seek=1; sync
+sudo dd if=SPL of=/dev/mmcblk0 bs=1k seek=1 conv=notrunc; sync
 
 - Flash the u-boot.img image into the micro SD card:
 
-sudo dd if=u-boot.img of=/dev/mmcblk0 bs=1k seek=69; sync
+sudo dd if=u-boot.img of=/dev/mmcblk0 bs=1k seek=69 conv=notrunc; sync
 
 - Jumper settings:
 
diff --git a/board/freescale/mx6ullevk/README b/board/freescale/mx6ullevk/README
index d5c8770863..47a35f61a2 100644
--- a/board/freescale/mx6ullevk/README
+++ b/board/freescale/mx6ullevk/README
@@ -15,7 +15,7 @@ This generates the u-boot-dtb.imx image in the current directory.
 
 - Flash the u-boot-dtb.imx image into the micro SD card:
 
-$ sudo dd if=u-boot-dtb.imx of=/dev/sdb bs=1K seek=1 && sync
+$ sudo dd if=u-boot-dtb.imx of=/dev/sdb bs=1K seek=1 conv=notrunc && sync
 
 - Jumper settings:
 